{ open Rules_parser;; }

rule rules_lex =
  parse

  "<<" { IS_TOLD }
| "$"  { POSSESSES }
| "|~" { ONCE_CONVEYED }
| "|=" { BELIEVES }
| "#"  { FRESH }
| "%"  { RECOGNIZABLE }

| "<-" { LEFT_ARROW }
| "->" { RIGHT_ARROW }
| "|-" { VDASH }

| "{"  { ENCRYPT_LEFT }
| "}"  { ENCRYPT_RIGHT }
| "+"  { PLUS }
| "-"  { MINUS }

| ","  { COMMA }
| "("  { PAREN_LEFT }
| ")"  { PAREN_RIGHT }
| ";;" { DELIMITER }
| ';' { SEMICOLON }
| ':' { COLON }
| '/' { SLASH }
| '!' { EXCLAMATION_POINT }
| '*' { STAR }

| "@@@" { HONEST_AND_COMPETENT }
| "=>"  { DOUBLE_RIGHT_ARROW }
| "~>"  { CURVY_RIGHT_ARROW }

| "DESTRUCT" { DESTRUCT }
| "CONSTRUCT" { CONSTRUCT }
| "EQUIVALENCE" { EQUIVALENCE }

| ['0'-'9' 'a'-'z' 'A'-'Z' '_'] ['0'-'9' 'a'-'z' 'A'-'Z' '_' '\'']*
     { Identifier(Lexing.lexeme lexbuf) }
| [' ' '\t' '\n']+ {rules_lex lexbuf}
| "(*" { comment lexbuf; rules_lex lexbuf }
| eof { EOF }

and comment =
  parse

  "*)" { () }
| "(*" { comment lexbuf; comment lexbuf }
| _    { comment lexbuf }
